package com.cristobalbernal.loladvisor.dao;

import com.cristobalbernal.loladvisor.config.AppConfig;
import com.cristobalbernal.loladvisor.model.Lol;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;

@Repository
public class LolDaoImplMemory implements LolDao {
	
	public List<Lol> lol = new ArrayList<>();
	
	@Autowired
	private AppConfig appConfig;
	
	@PostConstruct
	public void init() {
		lol = UtilLolFileReader.readFile(appConfig.getFile(), appConfig.getSeparator(), appConfig.getListSeparator());
	}
	@Override
	public void buscarPorID(long id) {
		Optional<Lol> result = lol.stream().filter(lol -> lol.getId() == id).findFirst();
		System.out.println(result.orElse(null));
	}
	@Override
	public Collection<Lol> mostrarTodos() {
		return lol;
	}

	public void insertarPersonaje(Lol videogame) {
		lol.add(videogame);
	}
	@Override
	public void editarPersonaje(Lol videogame) {
		int i = getIndexOf(videogame.getId());
		if(i != -1) {
			lol.set(i, videogame);
		}
	}
	@Override
	public void eliminarPersonaje(long id) {
		int i = getIndexOf(id);
		if(i != -1) {
			lol.remove(i);
		}
	}

	@Override
	public void mostrarCantidadPersonajes() {
		System.out.println(lol.size());
	}

	private int getIndexOf(long id) {
		boolean founds = false;
		int i = 0;
		
		while(!founds && i < lol.size()) {
			if(lol.get(i).getId() == id) {
				founds = true;
			} else {
				i++;
			}
		}
		
		return (founds) ? i : -1;
	}

}
